#pragma once

#define CKR_OK					(0UL)
#define CKR_CANCEL				(1UL)
#define CKR_HOST_MEMORY				(2UL)
#define CKR_SLOT_ID_INVALID			(3UL)
#define CKR_GENERAL_ERROR			(5UL)
#define CKR_FUNCTION_FAILED			(6UL)
#define CKR_ARGUMENTS_BAD			(7UL)
#define CKR_NO_EVENT				(8UL)
#define CKR_NEED_TO_CREATE_THREADS		(9UL)
#define CKR_CANT_LOCK				(0xaUL)
#define CKR_ATTRIBUTE_READ_ONLY			(0x10UL)
#define CKR_ATTRIBUTE_SENSITIVE			(0x11UL)
#define CKR_ATTRIBUTE_TYPE_INVALID		(0x12UL)
#define CKR_ATTRIBUTE_VALUE_INVALID		(0x13UL)
#define CKR_ACTION_PROHIBITED			(0x1BUL)
#define CKR_DATA_INVALID			(0x20UL)
#define CKR_DATA_LEN_RANGE			(0x21UL)
#define CKR_DEVICE_ERROR			(0x30UL)
#define CKR_DEVICE_MEMORY			(0x31UL)
#define CKR_DEVICE_REMOVED			(0x32UL)
#define CKR_ENCRYPTED_DATA_INVALID		(0x40UL)
#define CKR_ENCRYPTED_DATA_LEN_RANGE		(0x41UL)
#define CKR_FUNCTION_CANCELED			(0x50UL)
#define CKR_FUNCTION_NOT_PARALLEL		(0x51UL)
#define CKR_FUNCTION_NOT_SUPPORTED		(0x54UL)
#define CKR_KEY_HANDLE_INVALID			(0x60UL)
#define CKR_KEY_SIZE_RANGE			(0x62UL)
#define CKR_KEY_TYPE_INCONSISTENT		(0x63UL)
#define CKR_KEY_NOT_NEEDED			(0x64UL)
#define CKR_KEY_CHANGED				(0x65UL)
#define CKR_KEY_NEEDED				(0x66UL)
#define CKR_KEY_INDIGESTIBLE			(0x67UL)
#define CKR_KEY_FUNCTION_NOT_PERMITTED		(0x68UL)
#define CKR_KEY_NOT_WRAPPABLE			(0x69UL)
#define CKR_KEY_UNEXTRACTABLE			(0x6aUL)
#define CKR_MECHANISM_INVALID			(0x70UL)
#define CKR_MECHANISM_PARAM_INVALID		(0x71UL)
#define CKR_OBJECT_HANDLE_INVALID		(0x82UL)
#define CKR_OPERATION_ACTIVE			(0x90UL)
#define CKR_OPERATION_NOT_INITIALIZED		(0x91UL)
#define CKR_PIN_INCORRECT			(0xa0UL)
#define CKR_PIN_INVALID				(0xa1UL)
#define CKR_PIN_LEN_RANGE			(0xa2UL)
#define CKR_PIN_EXPIRED				(0xa3UL)
#define CKR_PIN_LOCKED				(0xa4UL)
#define CKR_SESSION_CLOSED			(0xb0UL)
#define CKR_SESSION_COUNT			(0xb1UL)
#define CKR_SESSION_HANDLE_INVALID		(0xb3UL)
#define CKR_SESSION_PARALLEL_NOT_SUPPORTED	(0xb4UL)
#define CKR_SESSION_READ_ONLY			(0xb5UL)
#define CKR_SESSION_EXISTS			(0xb6UL)
#define CKR_SESSION_READ_ONLY_EXISTS		(0xb7UL)
#define CKR_SESSION_READ_WRITE_SO_EXISTS	(0xb8UL)
#define CKR_SIGNATURE_INVALID			(0xc0UL)
#define CKR_SIGNATURE_LEN_RANGE			(0xc1UL)
#define CKR_TEMPLATE_INCOMPLETE			(0xd0UL)
#define CKR_TEMPLATE_INCONSISTENT		(0xd1UL)
#define CKR_TOKEN_NOT_PRESENT			(0xe0UL)
#define CKR_TOKEN_NOT_RECOGNIZED		(0xe1UL)
#define CKR_TOKEN_WRITE_PROTECTED		(0xe2UL)
#define CKR_UNWRAPPING_KEY_HANDLE_INVALID	(0xf0UL)
#define CKR_UNWRAPPING_KEY_SIZE_RANGE		(0xf1UL)
#define CKR_UNWRAPPING_KEY_TYPE_INCONSISTENT	(0xf2UL)
#define CKR_USER_ALREADY_LOGGED_IN		(0x100UL)
#define CKR_USER_NOT_LOGGED_IN			(0x101UL)
#define CKR_USER_PIN_NOT_INITIALIZED		(0x102UL)
#define CKR_USER_TYPE_INVALID			(0x103UL)
#define CKR_USER_ANOTHER_ALREADY_LOGGED_IN	(0x104UL)
#define CKR_USER_TOO_MANY_TYPES			(0x105UL)
#define CKR_WRAPPED_KEY_INVALID			(0x110UL)
#define CKR_WRAPPED_KEY_LEN_RANGE		(0x112UL)
#define CKR_WRAPPING_KEY_HANDLE_INVALID		(0x113UL)
#define CKR_WRAPPING_KEY_SIZE_RANGE		(0x114UL)
#define CKR_WRAPPING_KEY_TYPE_INCONSISTENT	(0x115UL)
#define CKR_RANDOM_SEED_NOT_SUPPORTED		(0x120UL)
#define CKR_RANDOM_NO_RNG			(0x121UL)
#define CKR_DOMAIN_PARAMS_INVALID		(0x130UL)
#define CKR_BUFFER_TOO_SMALL			(0x150UL)
#define CKR_SAVED_STATE_INVALID			(0x160UL)
#define CKR_INFORMATION_SENSITIVE		(0x170UL)
#define CKR_STATE_UNSAVEABLE			(0x180UL)
#define CKR_CRYPTOKI_NOT_INITIALIZED		(0x190UL)
#define CKR_CRYPTOKI_ALREADY_INITIALIZED	(0x191UL)
#define CKR_MUTEX_BAD				(0x1a0UL)
#define CKR_MUTEX_NOT_LOCKED			(0x1a1UL)
#define CKR_NEW_PIN_MODE			(0x1b0UL)
#define CKR_NEXT_OTP				(0x1b1UL)
#define CKR_EXCEEDED_MAX_ITERATIONS		(0x1c0UL)
#define CKR_FIPS_SELF_TEST_FAILED		(0x1c1UL)
#define CKR_LIBRARY_LOAD_FAILED			(0x1c2UL)
#define CKR_PIN_TOO_WEAK			(0x1c3UL)
#define CKR_PUBLIC_KEY_INVALID			(0x1c4UL)
#define CKR_FUNCTION_REJECTED			(0x200UL)


#define ERR_OK                            0 //No error
#define SECUROSYS_ERROR_BASE              ((unsigned long) (1ul << 31))
#define SYSTEM_ERROR_SUFFIX               ((unsigned long) (1ul << 30))

#define ERR_UNEXPECTED_DATA_TYPE          (SECUROSYS_ERROR_BASE +  1)
#define ERR_BUFFER_TOO_SMALL              (SECUROSYS_ERROR_BASE +  2)
#define ERR_DUPLICATE_ENTRY               (SECUROSYS_ERROR_BASE +  3)
#define ERR_NO_MORE_KEYS                  (SECUROSYS_ERROR_BASE +  4)
#define ERR_PUBLIC_KEY_NOT_FOUND          (SECUROSYS_ERROR_BASE +  5)
#define ERR_PRIVATE_KEY_NOT_FOUND         (SECUROSYS_ERROR_BASE +  6)
#define ERR_BLOCK_CIPHER_KEY_NOT_FOUND    (SECUROSYS_ERROR_BASE +  7)
#define ERR_INVALID_BLOCK_CIPHER          (SECUROSYS_ERROR_BASE +  8)
#define ERR_INVALID_MECHANISM             (SECUROSYS_ERROR_BASE +  9)
#define ERR_OBJECT_NOT_FOUND              (SECUROSYS_ERROR_BASE + 10)
#define ERR_LOGIN_FAILED                  (SECUROSYS_ERROR_BASE + 11)
#define ERR_USER_NOT_LOGGED_IN            (SECUROSYS_ERROR_BASE + 12)
#define ERR_USER_NOT_FOUND                (SECUROSYS_ERROR_BASE + 13)
#define ERR_KEY_PASS_MISMATCH             (SECUROSYS_ERROR_BASE + 14)
#define ERR_UNKNOWN_TYPE                  (SECUROSYS_ERROR_BASE + 15)
#define ERR_KEYPASS_NOT_FOUND             (SECUROSYS_ERROR_BASE + 16)
#define ERR_MISSING_PARAMETER             (SECUROSYS_ERROR_BASE + 17)
#define ERR_KEY_NOT_FOUND                 (SECUROSYS_ERROR_BASE + 18)
#define ERR_UNKNOWN_COMMAND               (SECUROSYS_ERROR_BASE + 19)
#define ERR_INVALID_SIZE                  (SECUROSYS_ERROR_BASE + 20)
#define ERR_USER_ALREADY_LOGGED_IN        (SECUROSYS_ERROR_BASE + 21)
#define ERR_LOGIN_PENDING                 (SECUROSYS_ERROR_BASE + 22)
#define ERR_SESSION_NOT_FOUND             (SECUROSYS_ERROR_BASE + 23)
#define ERR_MAX_CONNECTIONS_EXCEEDED      (SECUROSYS_ERROR_BASE + 24)
#define ERR_DESERIALIZATION_EXCESS_FIELDS (SECUROSYS_ERROR_BASE + 25)
#define ERR_LINE_ALREADY_ENCRYPTED        (SECUROSYS_ERROR_BASE + 26)
#define ERR_ENCRYPTION_NOT_SETUP          (SECUROSYS_ERROR_BASE + 27)
#define ERR_NO_UPDATE_PRESENT             (SECUROSYS_ERROR_BASE + 28)
#define ERR_UPDATE_FAILED                 (SECUROSYS_ERROR_BASE + 29)
#define ERR_CREATE_CLONE_FAILED           (SECUROSYS_ERROR_BASE + 30)
#define ERR_IMPORT_CLONE_FAILED           (SECUROSYS_ERROR_BASE + 31)
#define ERR_NOT_ALLOWED                   (SECUROSYS_ERROR_BASE + 32)
#define ERR_CRYPTO_NOT_AVAILABLE          (SECUROSYS_ERROR_BASE + 33)
#define ERR_NO_RENEGOTIATION_PENDING      (SECUROSYS_ERROR_BASE + 34)
#define ERR_CONNECTION_STATE_INVALID      (SECUROSYS_ERROR_BASE + 35)
#define ERR_RENEGOTIATION                 (SECUROSYS_ERROR_BASE + 36)
#define ERR_WRITING_LOG_FAILED            (SECUROSYS_ERROR_BASE + 37)
#define ERR_SET_TIME_FAILED               (SECUROSYS_ERROR_BASE + 38)
#define RESERVERED_ERROR                  (SECUROSYS_ERROR_BASE + 39)
#define ERR_NTP_RESTART_FAILED            (SECUROSYS_ERROR_BASE + 40)
#define ERR_CLONE_NOT_ALLOWED             (SECUROSYS_ERROR_BASE + 41)
#define ERR_KEY_IMPORT_NOT_ALLOWED        (SECUROSYS_ERROR_BASE + 42)
#define ERR_WRITE_CONFIG_FAILED           (SECUROSYS_ERROR_BASE + 43)
#define ERR_INVALID_ETHERNET_INTERFACE    (SECUROSYS_ERROR_BASE + 44)
#define ERR_INVALID_CONFIG_VALUE          (SECUROSYS_ERROR_BASE + 45)
#define ERR_CRYPTO_LOG_NOT_ALLOWED        (SECUROSYS_ERROR_BASE + 46)
#define ERR_NO_MORE_LOGS                  (SECUROSYS_ERROR_BASE + 47)
#define ERR_CONFIG_PARAM_NOT_MODIFIABLE   (SECUROSYS_ERROR_BASE + 48)
#define ERR_NO_MORE_USERS_ALLOWED         (SECUROSYS_ERROR_BASE + 49)
#define ERR_ROLLBACK_FAILED               (SECUROSYS_ERROR_BASE + 50)
#define ERR_NO_USB_DEVICE_PRESENT         (SECUROSYS_ERROR_BASE + 51)
#define ERR_DEVICE_NOT_READABLE           (SECUROSYS_ERROR_BASE + 52)
#define ERR_CLONE_KEY_NOT_RECOGNIZED      (SECUROSYS_ERROR_BASE + 53)
#define ERR_CREATE_CLONE_KEY_FAILED       (SECUROSYS_ERROR_BASE + 54)
#define ERR_PASSWORD_EXPIRED              (SECUROSYS_ERROR_BASE + 55)
#define ERR_PAYLOAD_TOO_BIG               (SECUROSYS_ERROR_BASE + 56)
#define ERR_LENGTH_MISMATCH               (SECUROSYS_ERROR_BASE + 57)
#define ERR_TIMER_CREATION_FAILED         (SECUROSYS_ERROR_BASE + 58)
#define ERR_CONNECT_TIMEOUT               (SECUROSYS_ERROR_BASE + 59)
#define ERR_ARCHIVE_FAILED                (SECUROSYS_ERROR_BASE + 60)
#define ERR_FAILED_TO_OPEN                (SECUROSYS_ERROR_BASE + 61)
#define ERR_SYSTEM_STATE_MISMATCH         (SECUROSYS_ERROR_BASE + 62)
#define ERR_OUT_OF_MEMORY                 (SECUROSYS_ERROR_BASE + 63)
#define ERR_XML_READ_ERROR                (SECUROSYS_ERROR_BASE + 64)
#define ERR_XML_WRITE_ERROR               (SECUROSYS_ERROR_BASE + 65)
#define ERR_SYSLOG_FAILED                 (SECUROSYS_ERROR_BASE + 66)
#define ERR_DHCP_FAILED                   (SECUROSYS_ERROR_BASE + 67)
#define ERR_NTPD_FAILED                   (SECUROSYS_ERROR_BASE + 68)
#define ERR_SYSTEM_TEST                   (SECUROSYS_ERROR_BASE + 69)
#define ERR_BOTAN_CRYPTO_OPERATION        (SECUROSYS_ERROR_BASE + 70)
#define ERR_INVALID_FLAG_COUNT            (SECUROSYS_ERROR_BASE + 71)
#define ERR_NO_SO_DATA_AVAILABLE          (SECUROSYS_ERROR_BASE + 72)
#define ERR_PRELOAD_FAILED                (SECUROSYS_ERROR_BASE + 73)
#define ERR_CONNECTION_EXPIRING           (SECUROSYS_ERROR_BASE + 74)
#define ERR_SNMP_FAILED                   (SECUROSYS_ERROR_BASE + 75)
#define ERR_IPTABLES_FAILED               (SECUROSYS_ERROR_BASE + 76)
#define ERR_LABEL_TOO_LONG                (SECUROSYS_ERROR_BASE + 77)
#define ERR_RECEIVE_ERROR                 (SECUROSYS_ERROR_BASE + 78)
#define ERR_BACKUP_RESTORE_NOT_ALLOWED    (SECUROSYS_ERROR_BASE + 79)
#define ERR_BACKUP_FAILED                 (SECUROSYS_ERROR_BASE + 80)
#define ERR_RESTORE_GENESIS_MISMATCH      (SECUROSYS_ERROR_BASE + 81)
#define ERR_RESTORE_FAILED                (SECUROSYS_ERROR_BASE + 82)
#define ERR_NO_BACKUP_KEY_AVAILABLE       (SECUROSYS_ERROR_BASE + 83)
#define ERR_NO_BACKUP_UID_AVAILABLE       (SECUROSYS_ERROR_BASE + 84)
#define ERR_KEY_EXPORT_NOT_ALLOWED        (SECUROSYS_ERROR_BASE + 85)
#define ERR_CLONE_KEY_CREATE_NOT_ALLOWED  (SECUROSYS_ERROR_BASE + 86)
#define ERR_NO_RESTORE_PIN_AVAILABLE      (SECUROSYS_ERROR_BASE + 87)
#define ERR_UNKNOWN_TYPE_CURVE            (SECUROSYS_ERROR_BASE + 88)
#define ERR_COMMUNICATION_VERSION         (SECUROSYS_ERROR_BASE + 89)
#define ERR_DEVICE_MISMATCH               (SECUROSYS_ERROR_BASE + 90)
#define ERR_NO_LICENSE_PRESENT            (SECUROSYS_ERROR_BASE + 91)
#define ERR_MODULE_NOT_LICENSED           (SECUROSYS_ERROR_BASE + 92)
#define ERR_GPIO                          (SECUROSYS_ERROR_BASE + 93)
#define ERR_USB_OVERCURRENT               (SECUROSYS_ERROR_BASE + 94)
#define ERR_FUNCTION_DISABLED             (SECUROSYS_ERROR_BASE + 95)
#define ERR_NODE_NOT_FOUND                (SECUROSYS_ERROR_BASE + 96)
#define ERR_CONFIG_MISMATCH               (SECUROSYS_ERROR_BASE + 97)
#define ERR_SAME_VALUE                    (SECUROSYS_ERROR_BASE + 98)
#define ERR_LICENSE_MISMATCH              (SECUROSYS_ERROR_BASE + 99)
#define ERR_CONFIG_CHANGE_ON_HA_CLONE     (SECUROSYS_ERROR_BASE + 100)
#define ERR_MASTER_NOT_REACHABLE          (SECUROSYS_ERROR_BASE + 101)
#define ERR_HA_REQUEST_TIMEOUT            (SECUROSYS_ERROR_BASE + 102)
#define ERR_HA_OBJECT_REJECTED            (SECUROSYS_ERROR_BASE + 103)
#define ERR_DEVICE_PARAMS_ACTIVE          (SECUROSYS_ERROR_BASE + 104)
#define ERR_USER_INTERFACE_DISABLED       (SECUROSYS_ERROR_BASE + 105)
#define ERR_CONFIG_CHANGE_ON_CLONE        (SECUROSYS_ERROR_BASE + 106)
#define ERR_CONFIG_CHANGE_ON_HA           (SECUROSYS_ERROR_BASE + 107)
#define ERR_FILE_NOT_FOUND                (SECUROSYS_ERROR_BASE + 108)
#define ERR_DECANUS_NOT_ALLOWED           (SECUROSYS_ERROR_BASE + 109)
#define ERR_NO_FILE_SELECTED              (SECUROSYS_ERROR_BASE + 110)
#define ERR_FILE_CREATION                 (SECUROSYS_ERROR_BASE + 111)
#define ERR_FILE_IO                       (SECUROSYS_ERROR_BASE + 112)
#define ERR_INVALID_INTERFACE_PROTOCOL    (SECUROSYS_ERROR_BASE + 113)
#define ERR_INVALID_DIAGNOSTICS           (SECUROSYS_ERROR_BASE + 114)
#define ERR_OPERATION_ABORTED             (SECUROSYS_ERROR_BASE + 115)
#define ERR_EKA_PARAMETERS_INVALID        (SECUROSYS_ERROR_BASE + 116)
#define ERR_EKA_GROUP_MISMATCH            (SECUROSYS_ERROR_BASE + 117)
#define ERR_EKA_TOKEN_NOT_FOUND           (SECUROSYS_ERROR_BASE + 118)
#define ERR_EKA_DELAY_NOT_YET_ELAPSED     (SECUROSYS_ERROR_BASE + 119)
#define ERR_EKA_TIME_LIMIT_EXCEEDED       (SECUROSYS_ERROR_BASE + 120)
#define ERR_EKA_TIMESTAMP_MISSING         (SECUROSYS_ERROR_BASE + 121)
#define ERR_EKA_OBJECT_BLOCKED            (SECUROSYS_ERROR_BASE + 122)
#define ERR_CORRUPT_VALUE                 (SECUROSYS_ERROR_BASE + 123)
#define ERR_ERRORS_OCCOURED               (SECUROSYS_ERROR_BASE + 124)
#define ERR_ALREADY_SETUP                 (SECUROSYS_ERROR_BASE + 125)
#define ERR_NOT_SETUP                     (SECUROSYS_ERROR_BASE + 126)
#define ERR_SIGNAL_NOT_PROCESSED          (SECUROSYS_ERROR_BASE + 127)

#define ERR_SYSTEM_ERROR(ERRNO)           (SECUROSYS_ERROR_BASE + SYSTEM_ERROR_SUFFIX + ERRNO) // uses error from errno

